// console.log = function(msg) {
//     alert(msg);
// };
(function(glb) {
    glb['chr'] = {};
    var chr = glb.chr;
    var isAndroid = /(Android)/i.test(navigator.userAgent);
    var isIOS = /(iPhone|iPad|iPod|iOS)/i.test(navigator.userAgent);
    //window.webkit.messageHandlers.chinahr.postMessage
    var chinahr = null;
    var bridge = {
    };
    if (glb.chinahr) {
        chinahr = glb.chinahr;
        console.log('android');
    } else if (glb.webkit && glb.webkit.messageHandlers && glb.webkit.messageHandlers.chinahr) {
        chinahr = glb.webkit.messageHandlers.chinahr;
        console.log('ios');
    } else {
        chinahr = {
            postMessage: function(url) {
                var name = /callback=([^&]*)/.exec(url)[1];
                console.log('callback:' + name);
                glb[name]('{"uid":"8cc8b0e4d706ea578b84b962j"}');
            }
        };
    }

    var url = 'chinahr://{method}?{params}&callback={callback}';

    function method(methodName) {
        var target = url
            .replace('{method}', methodName);
        var cbName = methodName.replace(/\//g, '_');
        return function(data, callback) {
            if (typeof data == 'function') {
                callback = data;
                data = '';
            }
            glb[cbName] = function(content) {
                console.log(cbName + '结果:' + content);
                callback && callback(content);
                delete glb[cbName];
            };
            var path = '';
            if (typeof data == 'string') {
                path = data;
            } else {
                for (var pro in data) {
                    path += ('&' + pro + '=' + data[pro]);
                }
            }

            var url = target.replace('{params}', path)
                .replace('{callback}', cbName);

            console.log('post:' + url);
            chinahr.postMessage(url);
        };
    }

    function nativeRead(path, callback) {
        chr.postMessage('native/read', path, function(content) {
            console.log('异步执行结果:' + content);
            if (content) {
                var code = glb.Base64.decode(content);
                callback && callback(code);
            } else {
                callback && callback('');
            }
        })
    }

    if (chinahr) {
        chr.storage = {
            get: nativeRead,
            set: function() { }
        };
    } else {
        chr.storage = false;
    }


    function getUserInfo(callback) {
        if (!chinahr.getUserInfo) {
            console.log('构建方法开始:native/getUserInfo');
            method('native/getUserInfo')(function(info){
                 callback && callback(JSON.parse(info));
            });
            console.log('构建方法完成:native/getUserInfo');

        } else {
            var result = chinahr.getUserInfo();
            console.log('同步执行结果:' + result);
            if (result) {
                callback && callback(JSON.parse(result));
            }
        }
    }
    chr.getUserInfo = getUserInfo;
    chr.registry = {};
    chr.postMessage = function(method, params, callback) {
        if (!chr.registry[method]) {
            chr.registry[method] = method(method);
        }
        chr.registry[method](params, callback);
    };

    if (typeof exports === 'object' && typeof module !== 'undefined') {
        module.exports = chr;
    }

})(window);